#include <stdio.h>

// x̒l[a, b]͈̔͂ɃNvD
float h_clamp(float x, float a, float b)
{
	if (x < a)
		x = a;
	if (x > b)
		x = b;
	return x;
}

// 0`255.0f̕_r, g, blFf[^𐶐D
int h_RGBToInt(float r, float g, float b)
{
    r = h_clamp(r, 0.0f, 255.0f);
    g = h_clamp(g, 0.0f, 255.0f);
    b = h_clamp(b, 0.0f, 255.0f);
    return (int(b) << 16) | (int(g) << 8) | int(r);
}

// CPUɂ鍷@vZD
void h_diffusion2D(unsigned int j, unsigned int i, float *F, float *Fn, unsigned int width, unsigned int height, float c0, float c1, float c2,
	float max_density, int *g_data)
// unsingned int j, i; iqXỸCfbNXD
// float *F; ݂̊iqf[^D
// float *Fn; XVꂽiqf[^D
// unsigned width, height; iqf[^XỶ𑜓xD
// float c0, c1, c2; @vŽWD
// float max_density; Zx̍őlD
// int *g_data; 摜f[^̏óD
{
    unsigned int index;
    float fc, fr, fl, fd, ft, density;

    // F[index]̎͂4vf(㉺E4vf)߂D
    index = width * i + j;
	fc = F[index];
    if (j == 0)
        fl = fc;
    else
        fl = F[index - 1];
    if (j == (width - 1)) 
        fr = fc;
    else             
        fr = F[index + 1];
	if (i == 0) 
        fd = fc;
    else        
        fd = F[index - width];
 	if (i == (height - 1))
        ft = fc;
    else             
        ft = F[index + width];
	Fn[index] = c0 * (fr + fl) + c1 * (ft + fd) + c2 * fc;
	density = 255.0f - Fn[index] / max_density * 255.5f;
	g_data[index] = h_RGBToInt(density, density, density);
}

// CPŰND
void launchCPUKernel(float *F, float *Fn, unsigned int width, unsigned int height, float dx, float dy, float kappa, float dt,
	float max_density, int *g_data)
// float *F; ݂̊iqf[^D
// float *Fn; XVꂽiqf[^D
// unsigned width, height; iqf[^XỶ𑜓xD
// float dx, dy; XY̊iqԊuD
// float kappa; gUWD
// float dt; ԊԊuD
// float max_density; Zx̍őlD
// int *g_data; 摜f[^̏óD
{
	unsigned int i, j;
    float c0, c1, c2;

    // @̌W̌D
    c0 = kappa * dt / (dx * dx);
    c1 = kappa * dt / (dy * dy);
    c2 = 1.0f - 2.0f * (c0 + c1);
	for (i = 0; i < height; i++) {
		for (j = 0; j < width; j++) {
			h_diffusion2D(j, i, F, Fn, width, height, c0, c1, c2, max_density, g_data);
		}
	}
}

